//  ** Revision History **
//  22-Jun-1992 (AH) Flyttad till PWB
//****************************************************************************                   
//                    Copyright (C) 1992 EuroSource AB
//
// FILE:        About.c         
//   
// PURPOSE:     Display an About Dialog box
//   
// COMMENTS:     
//   
// HISTORY:     920611AH Prehistory
//   
//****************************************************************************                                       

#include <windows.h>
#include <vbapi.h>

#include "eurotool.h" 
#include "esradio.h"

#ifndef RUNTIMEVERSION
#include "about.h"
#include "version.h"

extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   BOOL FAR SetAboutText(HCTL hctl, UINT prop)          
//
//      PURPOSE:    Set the About property string for a custom control.
//                  
//
//**************************************************************************

VOID FAR SetAboutText(HCTL hctl, UINT prop) 
{
    char    szBuffer[100], szTemp[100];
    
	// setup version number for Buttons
    if (!LoadString(hmodDLL, IDS_VERSION, szTemp, sizeof(szTemp)))
	 return;
    wsprintf(szBuffer, szTemp, CC_VER_MAJOR, CC_VER_MINOR, CC_VER_TREE, CC_VER_BUILD);
	VBSetControlProperty(hctl, prop, (LONG) (LPSTR) szBuffer);
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   HWND FAR HwndInitAboutPopup(VOID)          
//
//      PURPOSE:    Create our property popup-window.  Since we want to put up
//                  a dialog, this window never becomes visible. Instead, when 
//                  asked to become visible it will post itself a message, 
//                  remining it to put up our dialog.
//                  
//      COMMENTS    May return NULL!       
//
//      HISTORY:    910611AH Prehistory     
//
//**************************************************************************

HWND FAR HwndInitAboutPopup(VOID)
{
    return CreateWindow("AboutClass", NULL, WS_POPUP,
		      0, 0, 0, 0, NULL, NULL,
		      hmodDLL, NULL);
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    We asked to show ourself, remain invisible and post a
//                  CM_OPENABOUTDLG to ourself. When we receive this message,
//                  open the dialog box.     
//
//      COMMENTS:        
//
//      HISTORY:    920611AH         
//
//**************************************************************************

LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp)
{
    extern HANDLE hmodDLL;

    switch (msg)
    {
	case WM_SHOWWINDOW:
		if (wp) 
	    {
			PostMessage(hwnd, CM_OPENABOUTDLG, 0, 0L);
			return 0L;
		}
			break;

	case CM_OPENABOUTDLG:
			VBDialogBoxParam(hmodDLL, "AboutDlgBox", AboutDlgProc, 0L);
		return 0L;
    }

    return DefWindowProc(hwnd, msg, wp, lp);
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   BOOL FAR PASCAL _export AboutDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    The Dialog procedure for the About dialog.     
//
//      COMMENTS:        
//
//      HISTORY:    920611AH     
//
//**************************************************************************



BOOL FAR PASCAL _export AboutDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp)
{

    switch (msg)
    {
    case WM_INITDIALOG: {
	RECT rect;
	int  nx, ny;      // New x and y
	int  width, height;
	int          idModeString ;
	char         szBuffer[100], szTemp[100];
	DWORD        dwFreeMemory, dwWinFlags;
	WORD         wFreeResources, wRevision, wVersion;

	// Position dialog so it looks nice:
	GetWindowRect(hDlg, &rect);
	width  = rect.right - rect.left;
	height = rect.bottom - rect.top;
	nx = (GetSystemMetrics(SM_CXSCREEN) - width)  / 2;
	ny = (GetSystemMetrics(SM_CYSCREEN) - height) / 3;
	MoveWindow(hDlg, nx, ny, width, height, FALSE); 

	// sets up the version number for Windows
	wVersion = LOWORD( GetVersion() ) ;
	switch (HIBYTE( wVersion ))
	{
	    case 10:
	       wRevision = 1 ;
	       break ;

	    default:
	       wRevision = 0 ;
	       break;
	}
	wVersion &= 0xFF ;

	GetDlgItemText( hDlg, IDD_TITLELINE, szTemp, sizeof(szTemp));
	wsprintf( szBuffer, szTemp, wVersion, wRevision);
	SetDlgItemText( hDlg, IDD_TITLELINE, szBuffer);

	// sets up version number for Buttons
	GetDlgItemText( hDlg, IDD_VERSION, szTemp, sizeof(szTemp));
	wsprintf( szBuffer, szTemp, VER_MAJOR, VER_MINOR, VER_TREE, VER_BUILD);
	SetDlgItemText( hDlg, IDD_VERSION, (LPSTR) szBuffer);
	
	// sets up version number for Custom Control
	GetDlgItemText( hDlg, IDD_BYLINE, szTemp, sizeof(szTemp));
	wsprintf( szBuffer, szTemp, CC_VER_MAJOR, CC_VER_MINOR, CC_VER_TREE, CC_VER_BUILD);
	SetDlgItemText( hDlg, IDD_BYLINE, (LPSTR) szBuffer);
	
	// set windows mode information
	dwWinFlags = GetWinFlags() ;
	if (dwWinFlags & WF_ENHANCED)
	    idModeString = IDS_MODE_ENHANCED ;
	else if (dwWinFlags & WF_STANDARD)
	    idModeString = IDS_MODE_STANDARD ;
	else if (dwWinFlags & WF_WLO)
	    idModeString = IDS_MODE_WLO ;
	else
	    idModeString = IDS_MODE_UNDEF ;

	LoadString( hmodDLL, idModeString, szBuffer,
		     sizeof( szBuffer ) ) ;
	SetDlgItemText( hDlg, IDD_WINDOWSMODE, szBuffer ) ;

	// get free memory information
	dwFreeMemory = GetFreeSpace( 0 ) / 1024L ;
	GetDlgItemText( hDlg, IDD_FREEMEM, szTemp, sizeof( szTemp ) ) ;
	wsprintf( szBuffer, szTemp, dwFreeMemory ) ;
	SetDlgItemText( hDlg, IDD_FREEMEM, (LPSTR) szBuffer ) ;

	// get free resources information
	wFreeResources = GetFreeSystemResources( 0 ) ;
	GetDlgItemText( hDlg, IDD_RESOURCES, szTemp, sizeof( szTemp ) ) ;
	wsprintf( szBuffer, szTemp, wFreeResources ) ;
	SetDlgItemText( hDlg, IDD_RESOURCES, (LPSTR) szBuffer ) ;
	return TRUE; 
    }

	case WM_COMMAND:
	    switch (wp) {
		case IDOK:
		    EndDialog(hDlg, TRUE);
		    return TRUE;
		}
	    break;
    }
    return FALSE;
}

#endif //runtime version
