//  ** Revision History **
//  14-Oct-1992 (AH) Working an up.
//  21-Okt-1992 (AH) Beginning of history
//****************************************************************************                   
//                    Copyright (C) 1992 EuroSource AB
//
// FILE:        ColorBar.c         
//   
// PURPOSE:     Display an ColorBar box
//   
// COMMENTS:     
//   
//****************************************************************************                                       

#include <windows.h>
#include <vbapi.h>

#include "eurotool.h"
#include "esradio.h"

#ifndef RUNTIMEVERSION
#include "colorbar.h"
 
// internal prototypes
VOID NEAR DrawColorItem(UINT id, LPDRAWITEMSTRUCT lpdis);

// globals
LONG    colors[64] = {
    0x00ffffff, 0x00e0e0e0, 0x00c0c0ff, 0x00c0e0ff,
	0x00e0ffff, 0x00c0ffc0, 0x00ffffc0, 0x00ffc0c0,
	0x00ffc0ff, 0x000000c0, 0x000040c0, 0x0000c0c0,
	0x0000c000, 0x00c0c000, 0x00c00000, 0x00c000c0,
    
	0x00c0c0c0, 0x00404040, 0x008080ff, 0x0080c0ff,
	0x0080ffff, 0x0080ff80, 0x00ffff80, 0x00ff8080,
	0x00ff80ff, 0x00000080, 0x00004080, 0x00008080,
	0x00008000, 0x00808000, 0x00800000, 0x00800080,

	0x00808080, 0x00000000, 0x000000ff, 0x000080ff,
	0x0000ffff, 0x0000ff00, 0x00ffff00, 0x00ff0000,
	0x00ff00ff, 0x00000040, 0x00404080, 0x00004040,
	0x00004000, 0x00404000, 0x00400000, 0x00400040,

	0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
    0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
    0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
	0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
};    
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   HWND FAR HwndInitColorPopup(VOID)          
//
//      PURPOSE:    Create our colorbar popup-window.  Since we want to put up
//                  a dialog, this window never becomes visible. Instead, when 
//                  asked to become visible it will post itself a message, 
//                  remining it to put up our dialog.
//                  
//      COMMENTS    May return NULL!       
//
//**************************************************************************

HWND FAR HwndInitColorPopup(VOID)
{
    return CreateWindow("EsColorClass", NULL, WS_POPUP,
		      0, 0, 0, 0, NULL, NULL,
		      hmodDLL, NULL);
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export ColorPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    We asked to show ourself, remain invisible and post a
//                  CM_OPENCOLORDLG to ourself. When we receive this message,
//                  open the dialog box.     
//
//      COMMENTS:        
//
//**************************************************************************

LONG FAR PASCAL _export ColorPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp)
{
    extern HANDLE hmodDLL;

    switch (msg)
    {
	case WM_SHOWWINDOW:
		if (wp) 
	    {
			PostMessage(hwnd, CM_OPENCOLORDLG, 0, 0L);
			return 0L;
		}
			break;

	case CM_OPENCOLORDLG:
			VBDialogBoxParam(hmodDLL, "ColorDlgBox", ColorDlgProc, 0L);
		return 0L;
    }

    return DefWindowProc(hwnd, msg, wp, lp);
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   BOOL FAR PASCAL _export ColorDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    The Dialog procedure for the Color dialog.     
//
//      COMMENTS:        
//
//**************************************************************************

BOOL FAR PASCAL _export ColorDlgProc(HWND hDlg, USHORT msg, USHORT wp, LONG lp)
{               
		   
    switch (msg)
    {
	case WM_INITDIALOG: 
	{
		RECT rect;
		int  nx, ny;      // New x and y
		int  width, height;

		// Position dialog so it looks nice:
		GetWindowRect(hDlg, &rect);
		width  = rect.right - rect.left;
		height = rect.bottom - rect.top;
		nx = (GetSystemMetrics(SM_CXSCREEN) - width)  / 2;
		ny = (GetSystemMetrics(SM_CYSCREEN) - height) / 3;
		MoveWindow(hDlg, nx, ny, width, height, FALSE);
		break;
		}         
    
	/* Masked out: must select a color.
	case WM_LBUTTONDOWN:
	{
	    POINT       pt;
	    RECT        rc;
				     
	    pt.x = LOWORD(lp);
	    pt.y = HIWORD(lp);
	    
			GetClientRect(hDlg, &rc); 
	    
		if (!PtInRect(&rc, pt)) 
		EndDialog(hDlg, TRUE);
	}    
	break;
	*/
	
	case WM_COMMAND:
		if (wp >= COLOR00 && wp <= COLOR315)
		{   
		if (HIWORD(lp) == BN_CLICKED) 
		{
			VBSetControlProperty(hctlDialog, ipropDialog, colors[wp-COLOR00]);    
				EndDialog(hDlg, TRUE);
		}
			return TRUE;
		}     
		break; 
       
	case WM_DRAWITEM:
		DrawColorItem(wp, (LPDRAWITEMSTRUCT)lp); 
		break;
    }
    
    return FALSE;
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawColorItem(UINT id, LPDRAWITEMSTRUCT lpdis)       
//
//      PURPOSE:        Draw one color button.     
//
//      COMMENTS:        
//
//************************************************************************** 

VOID NEAR DrawColorItem(UINT id, LPDRAWITEMSTRUCT lpdis)
{       
    HBRUSH      hbrush, hbrushBlack;
			  
    
    hbrushBlack = CreateSolidBrush(RGBCOLOR(BLACK));
    hbrush = CreateSolidBrush(RGBCOLOR(colors[lpdis->CtlID-COLOR00]));
    
	switch (lpdis->itemAction)
    {
	
	case ODA_DRAWENTIRE:
		FillRect(lpdis->hDC, &lpdis->rcItem, hbrush);
		FrameRect(lpdis->hDC, &lpdis->rcItem, hbrushBlack);
		break;
    
	case ODA_FOCUS:
		break;
    
	case ODA_SELECT:
		break;    
    }
	DeleteObject(hbrush);
	DeleteObject(hbrushBlack);    
}


#endif //runtime version
