ORIGIN = PWB
ORIGIN_VER = 2.1.49
PROJ = esradio
PROJFILE = esradio.mak
DEBUG = 0

CC  = cl
CFLAGS_G  = /Alnw /W2 /G2 /Gc /GD /Zp /BATCH
CFLAGS_D  = /f /Od /Zi /Gs
CFLAGS_R  = /f- /Os /Og /Oe /Gs
CXX  = cl
CXXFLAGS_G  = /G2 /W2 /ASw /GD /Zp /BATCH
CXXFLAGS_D  = /f /Zi /Od /Gs
CXXFLAGS_R  = /f- /Oe /Og /Os /Gs
PBTDEPEND  = $(PROJ).vbx
PREP  = prep
PROFILE  = profile
PLIST  = plist
PROFSET  = set
PROFNMAKE  = nmake
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  =  /BATCH /ONERROR:NOEXE
LFLAGS_D  = /CO /NOF
LFLAGS_R  = /NOF
LLIBS_G  = LIBW.LIB vbapi.lib ver.lib
LINKER  = link
ILINK  = ilink
LRF  = echo > NUL
ILFLAGS  = /a /e
RC  = rc
IMPLIB  = implib
LLIBS_R  = /NOD:MLIBCE MDLLCEW
LLIBS_D  = /NOD:MLIBCE MDLLCEW
RCFLAGS2  = /30

FILES  = ABOUT.C CCINIT.C COLORBAR.C ESRADIO.DEF ESRADIO.RC EUROTOOL.C RADIO.C
DEF_FILE  = ESRADIO.DEF
OBJS  = ABOUT.obj CCINIT.obj COLORBAR.obj EUROTOOL.obj RADIO.obj
RESS  = ESRADIO.res

all: $(PROJ).vbx

.SUFFIXES:
.SUFFIXES:
.SUFFIXES: .obj .res .c .rc

ABOUT.obj : ABOUT.C eurotool.h esradio.h about.h version.h
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoABOUT.obj ABOUT.C
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoABOUT.obj ABOUT.C
<<
!ENDIF

CCINIT.obj : CCINIT.C esradio.h
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCCINIT.obj CCINIT.C
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCCINIT.obj CCINIT.C
<<
!ENDIF

COLORBAR.obj : COLORBAR.C eurotool.h esradio.h colorbar.h
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCOLORBAR.obj COLORBAR.C
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCOLORBAR.obj COLORBAR.C
<<
!ENDIF

ESRADIO.res : ESRADIO.RC esradio.h version.h colorbar.h
        $(RC) $(RCFLAGS1) /r /fo ESRADIO.res ESRADIO.RC

EUROTOOL.obj : EUROTOOL.C eurotool.h esradio.h
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoEUROTOOL.obj EUROTOOL.C
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoEUROTOOL.obj EUROTOOL.C
<<
!ENDIF

RADIO.obj : RADIO.C esradio.h version.h radio.h helpid.h
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoRADIO.obj RADIO.C
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoRADIO.obj RADIO.C
<<
!ENDIF


$(PROJ).pbt : 
        $(PROFSET) MAKEFLAGS=
        $(PROFNMAKE) $(NMFLAGS) -f $(PROJFILE) $(PBTDEPEND)
        $(PREP) /P $(PBTDEPEND) /OT $(PROJ).pbt

$(PROJ).dll : $(DEF_FILE) $(OBJS) $(RESS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
        $(LINKER) @$(PROJ).lrf
        $(RC) $(RCFLAGS2) $(RESS) $@
        $(IMPLIB) $*.lib $@

$(PROJ).vbx : $(DEF_FILE) $(OBJS) $(RESS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
        $(LINKER) @$(PROJ).lrf
        $(RC) $(RCFLAGS2) $(RESS) $@
        $(IMPLIB) $*.lib $@


.c.obj :
!IF $(DEBUG)
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /Fo$@ $<
<<
!ELSE
        @$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /Fo$@ $<
<<
!ENDIF

.rc.res :
        $(RC) $(RCFLAGS1) /r /fo $@ $<


run: $(PROJ).vbx
        

debug: $(PROJ).vbx
        
