//  ** Revision History **
//  29-Nov-1992 (AH) DrawFont3D moved from Push to this file
//  18-Nov-1992 (AH) GetHwnd added
//  22-Aug-1992 (AH) DrawButton moved from Counter.c and exported
//  22-Jun-1992 (AH) Flyttat till PWB
//****************************************************************************
//                      Copyright (C) 1992 EuroSource AB
//
// FILE:        Eurotool.c
//
// PURPOSE:     
//
// COMMENTS:
//
// HISTORY:     22-Jun-1992 Mon 02:44:24 AH  PREHISTORY
//
//****************************************************************************

#include <windows.h>
#include <vbapi.h>

#include    "eurotool.h" 
#include    "esradio.h"


//****************************************************************************
//                      Copyright (C) 1992 EuroSource AB
//
// FUNCTION:    VOID FAR PASCAL _export DrawButton(HDC hdc, LPRECT rect, LONG lightcolor, LONG darkcolor)
//
// PURPOSE:         Draws a generalized button
//
// COMMENTS:
//
// HISTORY:     14-Aug-1992 Fri 15:40:20 AH  PREHISTORY
//
//****************************************************************************

VOID FAR PASCAL _export DrawButton(HDC hdc, LPRECT rect, LONG lightcolor, LONG darkcolor)
{   
    HPEN        hOldPen, hPenLight, hPenDark;
    
    hPenLight  = CreatePen(PS_SOLID,1, RGBCOLOR(lightcolor)); 
    hPenDark   = CreatePen(PS_SOLID,1, RGBCOLOR(darkcolor));
    hOldPen = SelectObject(hdc, hPenLight);
	// draw Light part
    MoveTo(hdc,rect->left, rect->bottom);
	LineTo(hdc,rect->left, rect->top);
	LineTo(hdc,rect->right, rect->top);
	LineTo(hdc,rect->right-1, rect->top+1);
	LineTo(hdc,rect->left+1,rect->top+1);
	LineTo(hdc,rect->left+1,rect->bottom-1);  
    // select dark pen
    SelectObject(hdc, hPenDark);
	// draw ark part
    MoveTo(hdc, rect->left, rect->bottom);
	LineTo(hdc, rect->right, rect->bottom);
	LineTo(hdc, rect->right, rect->top);
	LineTo(hdc, rect->right-1, rect->top+1);
	LineTo(hdc, rect->right-1, rect->bottom-1);
	LineTo(hdc, rect->left+1, rect->bottom-1);
	SelectObject(hdc, hOldPen);
	DeleteObject(hPenLight);
	DeleteObject(hPenDark);
} 

//****************************************************************************
//                      Copyright (C) 1992 EuroSource AB
//
// FUNCTION:    HWND FAR PASCAL _export VBGetControlHwnd(hctl)
//
// PURPOSE              Get the windows handle for a given control.
//
// COMMENTS:
//
//****************************************************************************

HWND FAR PASCAL GethWnd(HCTL hctl)
{
	return VBGetControlHwnd(hctl);
}                                   

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID FAR PASCAL _export DrawFont3D(HDC hDC, LPSTR CaptionStr, LPRECT rect, SHORT align, SHORT type3D SHORT mode, DWORD txtcolor);   
//
//      PURPOSE:    Draws Captiontext Looking 3D     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//                  920526AH Now Supports Text Drawmode
//                  920604AH ForeColor support added via txtcolor
//
//**************************************************************************

VOID FAR PASCAL _export DrawFont3D(HDC hDC, LPSTR CaptionStr, LPRECT prect, SHORT align, SHORT type3D, SHORT mode, DWORD txtcolor)
{
    RECT  upper;
    RECT  lower;
      
    // Calculate the light rectangle
    lower.left = prect->left+1;
    lower.right = prect->right+1;
    lower.top = prect->top+1;
    lower.bottom = prect->bottom+1;  

    // Calculate the heavy rectangle
    upper.left = prect->left-1;
    upper.right = prect->right-1;
    upper.top = prect->top-1;
    upper.bottom = prect->bottom-1; 
     
    if (type3D != FONT3DNORMAL) 
    {
		// Draw the light rectangle   
		SetTextColor(hDC, RGBCOLOR(WHITE));
		SetBkMode(hDC, mode);
		DrawText(hDC,CaptionStr,-1,type3D<FONT3DRAISEDLIGHT ? (LPRECT)&lower : (LPRECT)&upper, align);
    }   
    
    if (type3D == FONT3DCARVEDHEAVY || type3D == FONT3DRAISEDHEAVY) 
    {         
		// Draw the heavy rectangle   
		SetTextColor(hDC, RGBCOLOR(DARKGREY));
		SetBkMode(hDC, mode);
		DrawText(hDC,CaptionStr,-1, type3D<FONT3DRAISEDLIGHT ? (LPRECT)&upper : (LPRECT)&lower, align);            
    }   
		
    // Draw standard text allways           
    SetBkMode(hDC, mode);
    SetTextColor(hDC, RGBCOLOR(txtcolor));
    DrawText(hDC,CaptionStr,-1,prect, align);
}           

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   BOOL FAR PASCAL EnumButtons(HWND hWnd, DWORD lp)       
//
//      PURPOSE:    Send a message to all other buttons in a group and
//                  give them a message (remove there clickmark).
//
//      COMMENTS:   lp is packed as:
//                      high :  message to send (BN_GROUPUP)
//                      low:    hWnd of radiobutton activating 
//
//                  The routine that retrive the message must check
//                  if they have the same parent otherwise we get in
//                  to trouble when we have buttons on the parentwindow.  
//
//      HISTORY:    920531AH Prehistory     
//
//**************************************************************************

BOOL FAR PASCAL _export EnumButtons(HWND hWnd, DWORD lp)
{
    SendMessage(hWnd, HIWORD(lp), LOWORD(lp), NULL); 
    return TRUE;  // continue until all of them handled   
}                                                             
