//  ** Revision History **
//  14-Jan-1993 (AH) Release 1.0.0.000
//  29-Dec-1992-1995 (AH) flicker problem fixed
//  13-Nov-1992-1995 (AH) Now select radiobutton when focus is received as VB does
//  13-Nov-1992 (AH) Support added for Mnenomic keys
//  14-Oct-1992 (AH) ColorBar added
//  03-Jul-1992 (AH) Focusrect problem with TextBorder fixed
//  03-Jul-1992 (AH) Grey style changed to Spade
//  03-Jul-1992 (AH) Problem with mark colors fixed
//  03-Jul-1992 (AH) About box added
//  24-Jun-1992 (AH) Now its impossible to have two option-boxes values set 
//                   to TRUE even when in designmode.
//  24-Jun-1992 (AH) Added Click Event Fire When VALUE-Property is set to TRUE
//  24-Jun-1992 (AH) Fire of Click Event Added
//  22-Jun-1992 (AH) Flyttat till PWB
//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         Radio.c  (part of EuoTool project)
//   
// PURPOSE:      Make a Ownerdrawn RadioButton
//   
// COMMENTS:     
//   
// HISTORY:      920527AH Prehistory
//   
//****************************************************************************                    
#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "esradio.h"


#include "version.h"
#include <string.h>
#define  CTL_DATA       // To declare static data in radio.h
#include "radio.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog; 
extern USHORT VBVersion;
HANDLE  ghWndRadio;              // handle for hWnd of Control     

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawRadio(HCTL hctl, LPDRAWITEMSTRUCT lpdi);
VOID NEAR RecalcAreaRadio(HCTL hctl, HWND hWnd);
BOOL FAR PASCAL _export EnumButtons(HWND hWnd, DWORD lp);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export RadioCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Radio Control Procedure     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

LONG FAR PASCAL _export RadioCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PRADIO      pradio;

    // Message pre-processing
    switch (msg) 
    {  
	case WM_CREATE:
	    pradio = RADIODEREF(hctl);
	    pradio->Light3DColor = WHITE;
	    pradio->Dark3DColor = DARKGREY;
	    pradio->RadioStyle = RADIONORMAL;
	    pradio->Align=TEXTTORIGHT;
	    pradio->Font3D=FONT3DNORMAL;
	    pradio->ToggleStatus = FALSE;
	    pradio->ParenthWnd = GetParent(hWnd);
	    pradio->FocusRectOn = TRUE;             // Focus rectangle should be used
	    pradio->MarkFG = BLACK;
	    pradio->MarkBG = WHITE;
	    pradio->TextBorderAlign = HALIGNCENTER;

#ifndef RUNTIMEVERSION        	    
	    // set the property text for the About dialog
	    SetAboutText(hctl, IPROP_RADIO_ABOUT);
#endif
        	     
	    VBSetControlProperty(hctl, IPROP_RADIO_BACKCOLOR, 
				       RADIO_BACKGROUND_DEFAULT);
	break;

#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_RADIO_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_RADIO_ALIGN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_alignment);
			    		return 0L;                                                        
                
            		case IPROP_RADIO_DARK3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_dark3dcolor);
			    		return 0L;                                            
            
            		case IPROP_RADIO_FOCUSRECTON:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_focusrecton);
			    		return 0L;                                            
            
            		case IPROP_RADIO_FONT3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_font3d);
			    		return 0L;                                       
            
            		case IPROP_RADIO_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                      
            
            		case IPROP_RADIO_LIGHT3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_light3dcolor);
			    		return 0L;                                             
            
                	case IPROP_RADIO_MARKBG:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markbackground);
			    		return 0L;                                            
                     
                	case IPROP_RADIO_MARKFG:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_markforeground);
			    		return 0L;                                      
                                                                             
                	case IPROP_RADIO_PICTUREDOWN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedown);
			    		return 0L;
                    
                    case IPROP_RADIO_PICTUREUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_pictureup);
			    		return 0L;
                    
                    case IPROP_RADIO_PICTUREDISABLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedisabled);
			    		return 0L; 
                    
					case IPROP_RADIO_STYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style);
			    		return 0L; 
                    
					case IPROP_RADIO_TOGGLESTATUS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;                                             
                
                	case IPROP_RADIO_TEXTBORDER:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_textborder);
			    		return 0L;                                                    
                
                	case IPROP_RADIO_TEXTBORDERALIGN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_textborderalign);
			    		return 0L;
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esradio);
		    return 0L;
	}
	break;                  
        	
	case VBM_INITPROPPOPUP:
	switch (wp) 
	{
		case IPROP_RADIO_ABOUT:
		    hctlDialog  = hctl;
			ipropDialog = wp;
			return (LONG)HwndInitAboutPopup();
					   
	    case IPROP_RADIO_MARKFG:
	    case IPROP_RADIO_MARKBG:
		case IPROP_RADIO_DARK3DCOLOR:
		case IPROP_RADIO_LIGHT3DCOLOR:
			if (VBVersion < 0x0200) 
			{
				hctlDialog  = hctl;
				ipropDialog = wp;
				return (LONG)HwndInitColorPopup();
			}
	}
	break;

#endif
        	
	case WM_ERASEBKGND:
	    // Don't bother with erasing the background
	    return TRUE;
    
    case VBM_GETDEFSIZE:
        return MAKELONG(RADIO_DEFAULTWIDTH,RADIO_DEFAULTHEIGHT);
    
	case WM_SIZE:
	    RecalcAreaRadio(hctl, hWnd); 
	    break;
		     
	case WM_SETFONT:
	    pradio = RADIODEREF(hctl);
	    pradio->hfont = (HFONT)wp;
	    
	    return(0L);

	case WM_GETFONT:
	    pradio = RADIODEREF(hctl);
	    return (pradio->hfont);

	case WM_SETTEXT:
	{
	    HSZ hsz;

	    pradio = RADIODEREF(hctl);
	    if (pradio->hszCaption) 
			VBDestroyHsz(pradio->hszCaption);
	    hsz = VBCreateHsz((_segment)hctl, (LPSTR)lp);
	    pradio = RADIODEREF(hctl);
	    pradio->hszCaption = hsz;
	    pradio->CaptionLen=lstrlen(VBDerefHsz(pradio->hszCaption));
	    RecalcAreaRadio(hctl, hWnd);
	    InvalidateRect(hWnd, NULL, TRUE);
	    return(0L);
	}
     
	case WM_GETTEXT:
	{    
	    LPSTR   lpstr;
	    WORD    cch;
	    
	    pradio = RADIODEREF(hctl);
	    if (pradio->hszCaption == NULL) 
	    {
			*(LPSTR)lp = 0L;
			wp = 1;
	    }
	    else 
	    {
			lpstr = VBDerefHsz(pradio->hszCaption);
			cch = lstrlen(lpstr) + 1;
			if (wp > cch)
		    	wp = cch;
			_fstrncpy((LPSTR)lp, lpstr, wp);
			((LPSTR)lp)[wp - 1] = '\0';
	    }
	}
	return (LONG)(wp - 1);

	case WM_GETTEXTLENGTH:
	    pradio = RADIODEREF(hctl);
	    if (pradio->hszCaption == NULL) 
	    {
			pradio->CaptionLen=0;
			return(0L);
	    }    
	    else
			return (lstrlen(VBDerefHsz(pradio->hszCaption)));
		   
	case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) 
	    {
			WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, esradio);
			return OK;
	    }
	    else
			break;
	
	case WM_LBUTTONUP:
		VBFireEvent(hctl, EVENT_RADIO_CLICK, NULL);
		break;
			   
	case VBM_SETPROPERTY:
	    switch (wp) 
	    {
		case IPROP_RADIO_CAPTION:
		    // To avoid a Windows problem, make sure text is
		    // under 255 bytes:
		    if (lstrlen((LPSTR)lp) > 255)
				*((LPSTR)lp + 255) = 0;
		    break;
		    
		case IPROP_RADIO_LIGHT3DCOLOR:
		case IPROP_RADIO_DARK3DCOLOR:
		case IPROP_RADIO_FONT3D:
		case IPROP_RADIO_STYLE:
		case IPROP_RADIO_ALIGN:
		case IPROP_RADIO_MARKFG:
		case IPROP_RADIO_MARKBG:
		case IPROP_RADIO_TEXTBORDER:
		case IPROP_RADIO_TEXTBORDERALIGN:
        case IPROP_RADIO_ENABLED:    
		    RecalcAreaRadio(hctl, hWnd);
		    InvalidateRect(hWnd, NULL, TRUE);
		    break;
        
		case IPROP_RADIO_TOGGLESTATUS:
		    RecalcAreaRadio(hctl, hWnd);
		    InvalidateRect(hWnd, NULL, TRUE);
		    if (RADIODEREF(hctl)->ToggleStatus) 
		    {     
				SendMessage(hWnd, VBN_COMMAND, BN_CLICKED, NULL);
				// Fire Click when set to TRUE  
				VBFireEvent(hctl, EVENT_RADIO_CLICK, NULL);
		    }
		    break;
	    }
	    break;

	case VBM_CHECKPROPERTY:
	    switch (wp)
	    {
		case IPROP_RADIO_PICTUREUP:
		case IPROP_RADIO_PICTUREDOWN: 
        case IPROP_RADIO_PICTUREDISABLED:    
		{
		    PIC pic;

		    VBGetPic((HPIC)lp, &pic);
		    switch (pic.picType) 
		    {
			case PICTYPE_NONE:
			case PICTYPE_BITMAP:
			    InvalidateRect(hWnd, NULL, TRUE);
			    return ERR_None;
		    }
		    return ERR_InvPropVal;
		}
		}
		break;
    
    case VBM_GETPROPERTY: 
    {
		if (wp == IPROP_RADIO_HWND) 
		{ 
			ghWndRadio = VBGetControlHwnd(hctl);
			(HWND *)lp = &ghWndRadio; 
			return OK;
		}   
		break; 
    }
    
    
	case VBN_DRAWITEM:
	    DrawRadio(hctl, (LPDRAWITEMSTRUCT)lp);
	    return 0;
	    
	case BN_GROUPUP:
	    pradio = RADIODEREF(hctl);
	    // Does we have the same parent?
	    if (GetParent(hWnd) == wp) 
	    {
		// yes! Marked?
		if (pradio->ToggleStatus) 
		{
		    pradio->ToggleStatus=FALSE;
		    InvalidateRect(hWnd, NULL, TRUE);
		}    
	    }
	    return TRUE;    
			  
	case WM_SETFOCUS:
	    SendMessage(hWnd, WM_COMMAND, 0, MAKELONG(hWnd,BN_CLICKED));
	    break;
	
	case VBN_COMMAND:    
	    switch(HIWORD(lp)) 
	    {
		case BN_CLICKED: 
		{
		    FARPROC lpProcEnumButtons;
		    
		    pradio = RADIODEREF(hctl);
		    lpProcEnumButtons=MakeProcInstance(EnumButtons,hmodDLL);
		    EnumChildWindows(GetParent(hWnd), lpProcEnumButtons, MAKELONG(GetParent(hWnd),BN_GROUPUP));
		    FreeProcInstance(lpProcEnumButtons);
		    pradio = RADIODEREF(hctl);
		    pradio->ToggleStatus = TRUE;                    
		    InvalidateRect(hWnd, NULL, TRUE);
		    return OK;
		}
	    }
	    break;    
    }

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) 
    {
	case WM_DESTROY:
	    VBFreePic(RADIODEREF(hctl)->hpicDown);
	    VBFreePic(RADIODEREF(hctl)->hpicUp);          
        VBFreePic(RADIODEREF(hctl)->hpicDisabled);
	    break;
    }
    return lResult;
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawRadio(HCTL hctl, LPDRAWITEMSTRUCT lpdi)       
//
//      PURPOSE:    Draw the Radio-button     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawRadio(HCTL hctl, LPDRAWITEMSTRUCT lpdi)
{
    PRADIO  pradio = RADIODEREF(hctl);
    LPRECT  prectALL = &pradio->rectDrawInto;
    LPRECT  prectText = &pradio->rectText;
    LPRECT  prectCircle = &pradio->rectCircle;
    HPIC    hpic;
    PIC     pic;
    HBITMAP     hbmp, hbmpOld;
    BITMAP  bmp;
    HDC     hdcMem, hdcClient;
    HBRUSH  hOldBrush;
    HBRUSH  hBrush;
    HBRUSH  hBrushBlack;
    HBRUSH  hBrushWhite;
    HBRUSH  hBrush3DLight;
    HBRUSH  hBrush3DDark;
    HBRUSH  hBrushMark;
    HBRUSH      hBrushMarkFG;
    HPEN    hOldPen;
    HPEN    hPenLight;
    HPEN    hPenDark;
    HPEN    hPenBlack;
    HPEN    hPenWhite;
    HPEN    hPenGrey;
    HPEN    hPenMark;
    HPEN    hPenMarkWide;
    HFONT   hOldFont;
    BOOL    fEnabled;
    DWORD   te;                 // text extent 
     
    
    // check if control is enabled
    VBGetControlProperty(hctl, IPROP_RADIO_ENABLED, (BOOL FAR *)&fEnabled);
		       
    switch (lpdi->itemAction) 
    {
	case ODA_DRAWENTIRE:
	    
	    hdcClient = CreateCompatibleDC(lpdi->hDC);
	    hbmp = CreateCompatibleBitmap(lpdi->hDC,
									prectALL->right-prectALL->left,
									prectALL->bottom-prectALL->top);
	    
	    if (hbmp == NULL || hdcClient == NULL)
		return;
	    
	    hbmpOld = SelectObject(hdcClient, hbmp); 
	    
	    // select Control Objects Font                             
		hOldFont = SelectObject(hdcClient, pradio->hfont);
	    
        if (fEnabled)
	    	hpic = (pradio->ToggleStatus) ? pradio->hpicDown : pradio->hpicUp;
        else
            hpic = pradio->hpicDisabled;
        
	    VBGetPic(hpic, &pic);
	    
	    // Select Control Objects Brush
	    hBrush = (HBRUSH)SendMessage(GetParent(lpdi->hwndItem), WM_CTLCOLOR, lpdi->hDC, 
					 MAKELONG(lpdi->hwndItem,0));
	    
	    // create pen's                             
	    hPenLight  = CreatePen(PS_SOLID,1, RGBCOLOR(pradio->Light3DColor)); 
	    hPenDark   = CreatePen(PS_SOLID,2, RGBCOLOR(pradio->Dark3DColor));
	    hPenWhite  = CreatePen(PS_SOLID,1, WHITE);
	    hPenBlack  = CreatePen(PS_SOLID,1, RGBCOLOR(BLACK));
	    hPenGrey   = CreatePen(PS_SOLID,1, RGBCOLOR(pradio->Dark3DColor));
	    hPenMark   = CreatePen(PS_SOLID,1, RGBCOLOR(pradio->MarkFG));
	    hPenMarkWide = CreatePen(PS_SOLID,2,RGBCOLOR(pradio->MarkFG)); 
	    
	    // create brush's 
	    hBrush3DLight = CreateSolidBrush(RGBCOLOR(pradio->Light3DColor));
	    hBrush3DDark  = CreateSolidBrush(RGBCOLOR(pradio->Dark3DColor));
	    hBrushBlack   = CreateSolidBrush(RGBCOLOR(BLACK));
	    hBrushWhite   = CreateSolidBrush(WHITE);
	    hBrushMark    = CreateSolidBrush(RGBCOLOR(pradio->MarkBG));
	    hBrushMarkFG  = CreateSolidBrush(RGBCOLOR(pradio->MarkFG));
	    
	    // Fill backgrund        
	    FillRect(hdcClient, prectALL, hBrush); 
	    
	    // Select new Pen & Brush
	    hOldPen = SelectObject(hdcClient, hPenLight);
	    hOldBrush = SelectObject(hdcClient, hBrush3DLight);
	    
	    switch(pradio->RadioStyle) 
	    {
		case RADIONORMAL:    
		case RADIOCOMPLETE:
		case RADIOGREY:
		case RADIOCROSSED:
		case RADIOCHECK:
		    SelectObject(hdcClient, hPenDark);
		    SelectObject(hdcClient, hBrushMark);
		    Ellipse(hdcClient, prectCircle->left-1, prectCircle->top,
					prectCircle->right, prectCircle->bottom);
		    SelectObject(hdcClient, hPenLight);                    
		    Ellipse(hdcClient, prectCircle->left+1, prectCircle->top+1,
					prectCircle->right+1, prectCircle->bottom+1);                    
		    SelectObject(hdcClient, hPenBlack);                    
		    Ellipse(hdcClient, prectCircle->left, prectCircle->top,
					prectCircle->right, prectCircle->bottom);
		    SelectObject(hdcClient, hPenGrey);                    
		    Arc(hdcClient, prectCircle->left, prectCircle->top,
				    prectCircle->right, prectCircle->bottom,
				    prectCircle->left+(prectCircle->right-prectCircle->left)/2,
				    prectCircle->bottom,                                      
				    prectCircle->left+(prectCircle->right-prectCircle->left)/2,
				    prectCircle->top);
				    
		    if (pradio->ToggleStatus) 
		    {
			if (pradio->RadioStyle==RADIONORMAL) 
			{
			    SelectObject(hdcClient, hBrushMarkFG);
			    Ellipse(hdcClient, prectCircle->left+3, prectCircle->top+3,
						prectCircle->right-3, prectCircle->bottom-3);     
			}
		    
			if (pradio->RadioStyle==RADIOCOMPLETE) 
			{
			    SelectObject(hdcClient, hBrushMarkFG);
			    Ellipse(hdcClient, prectCircle->left, prectCircle->top,
						prectCircle->right, prectCircle->bottom);     
			}
		    
			if (pradio->RadioStyle==RADIOGREY) 
			{
			    SelectObject(hdcClient, hPenMarkWide);
			    MoveTo(hdcClient, prectCircle->left+ 
						(prectCircle->right-prectCircle->left)/2,
						prectCircle->top+3);
				LineTo(hdcClient, prectCircle->left+3,
						prectCircle->top+
						(prectCircle->bottom-prectCircle->top)/2);
			    LineTo(hdcClient, prectCircle->left+ 
						(prectCircle->right-prectCircle->left)/2,
						prectCircle->bottom-3);
			    LineTo(hdcClient, prectCircle->right-3,
						prectCircle->top+
						(prectCircle->bottom-prectCircle->top)/2);
			    LineTo(hdcClient, prectCircle->left+ 
						(prectCircle->right-prectCircle->left)/2,
						prectCircle->top+3);                
			}                                                               
		    
			if (pradio->RadioStyle==RADIOCROSSED) 
			{
			    SelectObject(hdcClient, hPenMarkWide);
			    MoveTo(hdcClient, prectCircle->left+3, prectCircle->top+3);
			    LineTo(hdcClient, prectCircle->right-3, prectCircle->bottom-3);
			    MoveTo(hdcClient, prectCircle->left+3, prectCircle->bottom-3);
			    LineTo(hdcClient, prectCircle->right-3, prectCircle->top+3);
			}
		     
			if (pradio->RadioStyle==RADIOCHECK) 
			{
			    SelectObject(hdcClient, hPenMarkWide);
			    MoveTo(hdcClient, prectCircle->left+3, prectCircle->top+1);
			    LineTo(hdcClient, prectCircle->left+6, prectCircle->top+9);
			    LineTo(hdcClient, prectCircle->right-2, prectCircle->top-3);
			}
		    }                    
			break;              
		    
		case RADIOPICTURE:
		    // Only bitmap is accepted
		    if (pic.picType==PICTYPE_BITMAP) 
		    {
			GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
			hdcMem = CreateCompatibleDC(hdcClient);
			SelectObject(hdcMem, pic.picData.bmp.hbitmap);
			StretchBlt(hdcClient, prectCircle->left,  prectCircle->top,
				    (prectCircle->right - prectCircle->left),
				    (prectCircle->bottom - prectCircle->top),
				    hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
				    SRCCOPY);
			DeleteDC(hdcMem);
		    }
		    break; 
		    
		 case RADIOPICTURELARGE:
		    // Only bitmap is accepted
		    if (pic.picType==PICTYPE_BITMAP) 
		    {
			GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
			hdcMem = CreateCompatibleDC(hdcClient);
			SelectObject(hdcMem, pic.picData.bmp.hbitmap);
			StretchBlt(hdcClient, 
				    (pradio->Align==TEXTTORIGHT) ? prectALL->left : prectText->right+2,  
				    (pradio->Align==TEXTTORIGHT) ? prectALL->top  : prectText->top,
				    ((pradio->Align==TEXTTORIGHT) ? (prectText->left-prectALL->left-2) : 
								    (prectALL->right-prectText->right-2)),
				    (prectALL->bottom - prectALL->top),
				    hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
				    SRCCOPY);
			DeleteDC(hdcMem);
		    }
		    break;                         
	    }                        
	    
	    // draw text
	    if (pradio->CaptionLen != 0) 
	    {
		SelectObject(hdcClient, hBrush); 
		if (pradio->TextBorder == BORDERNONE) 
		{           
		    DrawFont3D(hdcClient, VBDerefHsz(pradio->hszCaption), &RADIODEREF(hctl)->rectText,
		    (((RADIODEREF(hctl)->Align == TEXTTORIGHT) ? DT_LEFT : DT_RIGHT) |
		    DT_VCENTER | DT_SINGLELINE), RADIODEREF(hctl)->Font3D, TRANSPARENT, fEnabled ? GetTextColor(lpdi->hDC) : DARKGREY);
		}
		else 
		{
		    int halign;
		    
		    switch(pradio->TextBorderAlign) 
		    {
			case HALIGNLEFT:
			    halign = DT_LEFT;
			    break;
			case HALIGNCENTER:
			    halign = DT_CENTER;
			    break;
			case HALIGNRIGHT:
			    halign = DT_RIGHT;
			    break;
		    }
		    DrawFont3D(hdcClient, VBDerefHsz(pradio->hszCaption), &RADIODEREF(hctl)->rectText,
				 (halign | DT_VCENTER | DT_SINGLELINE), RADIODEREF(hctl)->Font3D,
				 TRANSPARENT, fEnabled ? GetTextColor(lpdi->hDC) : DARKGREY);              
		}    
	    }
	    
	    // frame text
	    if (RADIODEREF(hctl)->TextBorder != BORDERNONE) 
	    {
		RECT    rect, rectupper, rectlower;
		
		pradio = RADIODEREF(hctl);
		
		// calculate frame rectangle
		rect.left   = (pradio->Align == TEXTTOLEFT) ? pradio->rectText.left-2: 
							      pradio->rectText.left-2;
		rect.top    = pradio->rectText.top+1;
		rect.right  = (pradio->Align == TEXTTOLEFT) ? pradio->rectText.right+3 : 
							      pradio->rectText.right+1;
		rect.bottom = pradio->rectText.bottom-2;
		
		// calculate upper rectangle
		rectupper.left   = rect.left-1;
		rectupper.top    = rect.top-1;
		rectupper.right  = rect.right-1;
		rectupper.bottom = rect.bottom-1;
		
		// calculate lower rectangle
		rectlower.left   = rect.left+1;
		rectlower.top    = rect.top+1;
		rectlower.right  = rect.right+1;
		rectlower.bottom = rect.bottom+1;
		
		switch(RADIODEREF(hctl)->TextBorder) 
		{
		    case BORDERFRAME:
			FrameRect(hdcClient, &rect, hBrushBlack);
			break;
		    
		    case BORDER3DCARVED:
			FrameRect(hdcClient, &rectupper, hBrush3DDark);
			FrameRect(hdcClient, &rectlower, hBrush3DLight);
			FrameRect(hdcClient, &rect, hBrush);                        
			break;
		    
		    case BORDER3DRAISED:
			FrameRect(hdcClient, &rectupper, hBrush3DLight);
			FrameRect(hdcClient, &rectlower, hBrush3DDark);
			FrameRect(hdcClient, &rect, hBrush);
			break;        
		}
	    }
	    
	    // Restore old objects
	    //   Font restored after Focus-work
	    SelectObject(hdcClient, hOldBrush); 
	    SelectObject(hdcClient, hOldPen);
	    
	    // no need to delete hBrush (VB rescurce)
	    DeleteObject(hPenBlack);
	    DeleteObject(hPenWhite);
	    DeleteObject(hPenLight);
	    DeleteObject(hPenDark);
	    DeleteObject(hPenGrey);
	    DeleteObject(hPenMark);
	    DeleteObject(hPenMarkWide);
	    DeleteObject(hBrush3DLight);
	    DeleteObject(hBrush3DDark);   
	    DeleteObject(hBrushWhite);
	    DeleteObject(hBrushBlack);
	    DeleteObject(hBrushMark);
	    DeleteObject(hBrushMarkFG);
		
        // Blit all of it to the screen	  
	    BitBlt(lpdi->hDC,
			prectALL->left,
			prectALL->top,
			prectALL->right-prectALL->top,
			prectALL->bottom-prectALL->top,
			hdcClient,
			0,0,
			SRCCOPY);    
	    
	    SelectObject(hdcClient, hOldFont);
	    SelectObject(hdcClient, hbmpOld);
	    DeleteObject(hbmp);
	    DeleteDC(hdcClient);
	    
	    // * * * FALL THROU * * *
	    
    case ODA_FOCUS:
	if (lpdi->itemState & ODS_FOCUS && RADIODEREF(hctl)->FocusRectOn) 
	{
	    RECT    FocusRect;
	    
	    // select Control Objects Font                             
	    pradio = RADIODEREF(hctl);
		hOldFont = SelectObject(lpdi->hDC, pradio->hfont);
	    
	    // get text extent           
	    te = GetTextExtent(lpdi->hDC, VBDerefHsz(RADIODEREF(hctl)->hszCaption),
					  RADIODEREF(hctl)->CaptionLen);
	    
	    pradio = RADIODEREF(hctl);
	    if (pradio->TextBorder == BORDERNONE) 
	    {
		FocusRect.left = (pradio->Align==TEXTTORIGHT)  ? pradio->rectText.left-2 : 
								 pradio->rectText.right-LOWORD(te)-2;
		FocusRect.right = (pradio->Align==TEXTTORIGHT) ? FocusRect.left+LOWORD(te)+2 : 
								 pradio->rectText.right+2;
		FocusRect.top = ((pradio->rectText.bottom - 
				  pradio->rectText.top)/2)-(HIWORD(te)/2)-2;
		FocusRect.bottom = FocusRect.top + HIWORD(te)+2;
	    }
	    else  
	    {
		FocusRect.left   = pradio->rectCircle.left-1;
		FocusRect.right  = pradio->rectCircle.right+1;
		FocusRect.top    = pradio->rectCircle.top-2;
		FocusRect.bottom = pradio->rectCircle.bottom+2;
	    }
	
	    DrawFocusRect(lpdi->hDC, &FocusRect);
		SelectObject(lpdi->hDC, hOldFont);
	}
	break;
    }
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaRadio(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the radiopicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920526AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaRadio(HCTL hctl, HWND hWnd)
{
    PRADIO  pradio = RADIODEREF(hctl);
    LPRECT  prectALL = &pradio->rectDrawInto;
    LPRECT  prectText = &pradio->rectText;
    LPRECT  prectCircle = &pradio->rectCircle;
    RECT    rectALL;
    SHORT   middle;
    
    // get the clientarea
    GetClientRect(hWnd, &rectALL);
    
    // calculate the window to work in 
    prectALL->left  = rectALL.left;
    prectALL->right = rectALL.right;
    prectALL->bottom=rectALL.bottom;
    prectALL->top   = rectALL.top;
    
    if (pradio->Align == TEXTTORIGHT) {
	// calculate radiosymbol rectangle
	middle = (prectALL->bottom-prectALL->top)/2;
	prectCircle->left = prectALL->left+RADIO_CIRCLEFROMBORDER;
	prectCircle->right = prectCircle->left+RADIO_CIRCLEHEIGHT;
	prectCircle->top = middle-(RADIO_CIRCLEHEIGHT/2);
	prectCircle->bottom = prectCircle->top+RADIO_CIRCLEHEIGHT;
    
	// calculate text rectangle
	prectText->left = prectALL->left+RADIO_TEXTFROMBORDER;
	prectText->right = prectALL->right-4;
	prectText->bottom = prectALL->bottom;
	prectText->top = prectALL->top; 
    }
    else {
	// calculate radiosymbol rectangle
	middle = (prectALL->bottom-prectALL->top)/2;
	prectCircle->left = prectALL->right-RADIO_CIRCLEFROMBORDER-RADIO_CIRCLEHEIGHT;
	prectCircle->right = prectCircle->left+RADIO_CIRCLEHEIGHT;
	prectCircle->top = middle-(RADIO_CIRCLEHEIGHT/2);
	prectCircle->bottom = prectCircle->top+RADIO_CIRCLEHEIGHT;
    
	// calculate text rectangle
	prectText->left = prectALL->left+4;
	prectText->right = prectALL->right-(RADIO_TEXTFROMBORDER);
	prectText->bottom = prectALL->bottom;
	prectText->top = prectALL->top;   
    }    
}    
