//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         radio.h
//   
// PURPOSE:      Header file for RADIO subclass EuroCtrl project
//   
// COMMENTS:     
//   
// HISTORY:      920525AH Prehistory
//   
//****************************************************************************                    


// Misc defines for Circle
#define RADIO_BACKGROUND_DEFAULT    GREY
#define RADIO_CIRCLEFROMBORDER      1
#define RADIO_CIRCLEHEIGHT          12
#define RADIO_TEXTFROMCIRCLE        6
#define RADIO_TEXTFROMBORDER        (RADIO_CIRCLEFROMBORDER+RADIO_CIRCLEHEIGHT+RADIO_TEXTFROMCIRCLE)
#define RADIO_DEFAULTWIDTH 			80
#define RADIO_DEFAULTHEIGHT         14

//---------------------------------------------------------------------------
// RADIO control data and structs
//---------------------------------------------------------------------------
typedef struct tagRADIO
{   HSZ		hszabout;
    HPIC    hpicUp;         // handle for picture up if any
    HPIC    hpicDown;       // handle for picture down if any
    HPIC	hpicDisabled;	// handle for disabled option button
    HWND    ParenthWnd;     // Handle to Parent
    RECT    rectDrawInto;   // interior to work in
    RECT    rectText;       // rectangle to display text in
    RECT    rectCircle;     // radiosymbol rectangle
    RECT    rectFocus;      // rectangle for Focus
    ENUM    alignment;      // 0=Text to the right/1=Text to the left
    LONG    Light3DColor;   // light part of 3D border
    LONG    Dark3DColor;    // Dark part of 3D border
    SHORT   Look3D;         // 3D look whanted.
    HFONT   hfont;          // handle to controls font
    HSZ     hszCaption;     // handle to caption string
    SHORT   CaptionLen;     // length for Captiontext;
    ENUM    Font3D;         // if 3D font whanted
    ENUM    RadioStyle;     // Stil fr radioknapp
    BOOL    ToggleStatus;   // Status: TRUE if selected
    BOOL    FocusRectOn;    // True if Focusrectangle
    ENUM    Align;          // Text placement
    LONG    MarkFG;         // Forground Color for mark
    LONG    MarkBG;         // BackGroundColor for mark
    ENUM    TextBorder;     // Attributes for textborder
    ENUM    TextBorderAlign; // Alignement in a textbox
} RADIO;

typedef RADIO FAR * PRADIO;

#define RADIODEREF(hctl)     ((PRADIO)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export RadioCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_RADIO_NAME            0
#define IPROP_RADIO_INDEX           1
#define IPROP_RADIO_PARENT          2
#define IPROP_RADIO_BACKCOLOR       3
#define IPROP_RADIO_LEFT            4
#define IPROP_RADIO_TOP             5
#define IPROP_RADIO_WIDTH           6
#define IPROP_RADIO_HEIGHT          7
#define IPROP_RADIO_ENABLED         8
#define IPROP_RADIO_VISIBLE         9
#define IPROP_RADIO_MOUSEPOINTER    10
#define IPROP_RADIO_CAPTION         11
#define IPROP_RADIO_FONTNAME        12
#define IPROP_RADIO_FONTSIZE        13
#define IPROP_RADIO_FONTBOLD        14
#define IPROP_RADIO_FONTITALIC      15
#define IPROP_RADIO_FONTSTRIKE      16
#define IPROP_RADIO_FONTUNDER       17
#define IPROP_RADIO_DRAG            18
#define IPROP_RADIO_DRAGICON        19
#define IPROP_RADIO_TABINDEX        20
#define IPROP_RADIO_TABSTOP         21
#define IPROP_RADIO_TAG             22
#define IPROP_RADIO_STYLE           23
#define IPROP_RADIO_FONT3D          24
#define IPROP_RADIO_DARK3DCOLOR     25
#define IPROP_RADIO_LIGHT3DCOLOR    26
#define IPROP_RADIO_FORECOLOR       27
#define IPROP_RADIO_TOGGLESTATUS    28
#define IPROP_RADIO_PICTUREUP       29
#define IPROP_RADIO_PICTUREDOWN     30
#define IPROP_RADIO_FOCUSRECTON     31
#define IPROP_RADIO_ALIGN           32
#define IPROP_RADIO_MARKFG          33
#define IPROP_RADIO_MARKBG          34
#define IPROP_RADIO_TEXTBORDER      35
#define IPROP_RADIO_TEXTBORDERALIGN 36
#define IPROP_RADIO_ABOUT			37
#define IPROP_RADIO_HWND			38 
#define IPROP_RADIO_PICTUREDISABLED 39

#ifdef CTL_DATA                       

PROPINFO Property_Radio_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(RADIO, hszabout)
}; 

PROPINFO propinfoRadioLight3DColor =
{
    "Light3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable| PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,Light3DColor), 0,
	WHITE
};

PROPINFO propinfoRadioDark3DColor =
{
    "Dark3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,Dark3DColor), 0,
	DARKGREY
};

PROPINFO propinfoRadioMarkFG =
{
    "MarkForeGround",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,MarkFG), 0,
	BLACK
};

PROPINFO propinfoRadioMarkBG =
{
    "MarkBackGround",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,MarkBG), 0,
	WHITE
};

// Radiobutton Styles
#define RADIONORMAL         0
#define RADIOCOMPLETE       1
#define RADIOGREY           2
#define RADIOCROSSED        3
#define RADIOCHECK          4
#define RADIOPICTURE        5
#define RADIOPICTURELARGE   6 

PROPINFO propinfoRadioStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,RadioStyle), 0,
    RADIONORMAL,
    "0 - Normal.\0"
    "1 - Complete fill.\0"
    "2 - Diamond.\0"
    "3 - Crossed.\0"
    "4 - Check.\0"
    "5 - Small Picture.\0"
    "6 - Large Picture.\0",
    RADIOPICTURELARGE
};

PROPINFO propinfoRadioFont3D =
{
    "Font3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,Font3D), 0,
    FONT3DNORMAL,
    "0 - Normal Text.\0"
    "1 - Carved light.\0"
    "2 - Carved Heavy.\0"
    "3 - Raised light.\0"
    "4 - Raised Heavy.\0",
    FONT3DRAISEDHEAVY
};

PROPINFO propinfoRadioToggleStatus =
{
    "Value",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(RADIO,ToggleStatus), 0,
	FALSE
};


PROPINFO propinfoRadioPictureUp =
{
    "PictureUp",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(RADIO,hpicUp), 0,
	0
};

PROPINFO propinfoRadioPictureDown =
{
    "PictureDown",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(RADIO,hpicDown), 0,
	0
};

PROPINFO propinfoRadioPictureDisabled =
{
    "PictureDisabled",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(RADIO,hpicDisabled), 0,
	0
};

PROPINFO propinfoRadioFocusRectOn =
{
    "FocusRectOn",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,FocusRectOn), 0,
	TRUE
};

// Textplacement for Radiobuttons
#define TEXTTORIGHT         0
#define TEXTTOLEFT          1  

PROPINFO propinfoRadioAlign =
{
    "Alignment",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,Align), 0,
    TEXTTORIGHT,
    "0 - Text to the Right.\0"
    "1 - Text to the Left.\0",
    TEXTTOLEFT
};

// Border around RadioButton text
#define BORDERNONE          0
#define BORDERFRAME         1
#define BORDER3DCARVED      2
#define BORDER3DRAISED      3 

PROPINFO propinfoRadioTextBorder =
{
    "TextBorder",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(RADIO,TextBorder), 0,
    BORDERNONE,
    "0 - No border around text.\0"
    "1 - Border around text.\0"
    "2 - 3D Carved border around text.\0"
    "4 - 3D Raised border around text.\0",
    BORDER3DRAISED
};

PROPINFO propinfoRadioTextBorderAlign =
{
    "TextBorderAlign",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(RADIO,TextBorderAlign), 0,
    HALIGNCENTER,
    "0 - Left.\0"
    "1 - Center.\0"
    "2 - Right.\0",
    HALIGNRIGHT
};

PROPINFO propinfoRadiohWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};

PPROPINFO proplistRadio[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    &propinfoRadioStyle,
    &propinfoRadioFont3D,
    &propinfoRadioDark3DColor,
    &propinfoRadioLight3DColor,
    PPROPINFO_STD_FORECOLOR,
    &propinfoRadioToggleStatus,
    &propinfoRadioPictureUp,
    &propinfoRadioPictureDown,
    &propinfoRadioFocusRectOn,
    &propinfoRadioAlign,
    &propinfoRadioMarkFG,
    &propinfoRadioMarkBG,
    &propinfoRadioTextBorder,
    &propinfoRadioTextBorderAlign,
    &Property_Radio_About,
    &propinfoRadiohWnd,        
    &propinfoRadioPictureDisabled,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_RADIO_CLICK       0
#define EVENT_RADIO_DBLCLICK    1
#define EVENT_RADIO_DRAGDROP    2
#define EVENT_RADIO_DRAGOVER    3
#define EVENT_RADIO_GOTFOCUS    4
#define EVENT_RADIO_KEYDOWN     5
#define EVENT_RADIO_KEYPRESS    6
#define EVENT_RADIO_KEYUP       7
#define EVENT_RADIO_LOSTFOCUS   8

#ifdef CTL_DATA
PEVENTINFO eventlistRadio[] =
{
    PEVENTINFO_STD_CLICK,
    PEVENTINFO_STD_DBLCLICK,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    PEVENTINFO_STD_GOTFOCUS,
    PEVENTINFO_STD_KEYDOWN,
    PEVENTINFO_STD_KEYPRESS,
    PEVENTINFO_STD_KEYUP,
    PEVENTINFO_STD_LOSTFOCUS,
    NULL
};
#endif  // CTL_DATA

//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelRadio =
{
    VB_VERSION,                 // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fMnemonic, // MODEL flags
    (PCTLPROC)RadioCtlProc,     // Control procedure
    CS_VREDRAW | CS_HREDRAW,    // Class style
    BS_AUTORADIOBUTTON | BS_OWNERDRAW,  // Default Window style
    sizeof(RADIO),              // cbCtlExtra for RADIO structure
    IDBMP_RADIO,                // Palette bitmap ID
    "EsOption",		       		// Default control name
    "EsOption",		       		// Visual Basic class name
    "Button",                   // Parent class name
    proplistRadio,              // Properties list
    eventlistRadio,             // Events list 
	IPROP_RADIO_CAPTION,		// default property
	EVENT_RADIO_CLICK,			// default event
	IPROP_RADIO_TOGGLESTATUS	// standard property
};
#endif  // CTL_DATA

LPMODEL modellistRadio[] =
    {
    &modelRadio,
    NULL
    };

MODELINFO modelinfoRadio =
    {
    VB_VERSION, 			// VB version being used
    modellistRadio			// MODEL list
    };


#endif  // RC_INVOKED

//---------------------------------------------------------------------------
